%define section free

Summary:        J2EE Unit Testing
Name:           mockrunner
Version:        0.3.5
Release:        1jpp
Epoch:          0
License:        Apache Software License -style
URL:            http://mockrunner.sourceforge.net/
Group:          Development/Libraries/Java
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        mockrunner-0.3.5.zip
Source1:        mockrunner-0.3.5-build.xml
Source2:        mockrunner-0.3.5-excluded.properties
BuildRequires:  ant >= 0:1.6, jpackage-utils >= 0:1.5
BuildRequires:  junit
BuildRequires:  j2sdkee-1.3-sun
BuildRequires:  java2html
BuildRequires:  nekohtml
BuildRequires:  jaranalyzer

BuildRequires:  cglib
BuildRequires:  jakarta-commons-beanutils
BuildRequires:  jakarta-commons-collections
BuildRequires:  jakarta-commons-digester
BuildRequires:  jakarta-commons-logging
BuildRequires:  jakarta-commons-validator
BuildRequires:  jboss4-j2ee
BuildRequires:  jdom
BuildRequires:  mockejb
BuildRequires:  oro
BuildRequires:  servletapi5
BuildRequires:  servletapi4
BuildRequires:  struts
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-apis

Requires:  cglib
Requires:  jakarta-commons-beanutils
Requires:  jakarta-commons-collections
Requires:  jakarta-commons-digester
Requires:  jakarta-commons-logging
Requires:  jakarta-commons-validator
Requires:  jdom
Requires:  mockejb
Requires:  oro
Requires:  servlet
Requires:  struts
Requires:  xerces-j2
Requires:  xml-commons-apis
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Mockrunner is a lightweight framework for unit testing 
applications in the J2EE environment. It supports Struts 
actions and forms, servlets, filters and tag classes. 
Furthermore it includes a JDBC and a JMS test framework 
and can be used in conjunction with MockEJB to test EJB 
based applications. 
Mockrunner extends JUnit and simulates the necessary 
behaviour without calling the real infrastructure. It does 
not need a running application server or a database. 
Furthermore it does not call the webcontainer or the Struts 
ActionServlet. It is very fast and enables the user to 
manipulate all involved classes and mockobjects in all steps 
of the test. It can be used to write very sophisticated 
unit-tests for J2EE based applications without any overhead. 
Mockrunner does not support any type of in-container testing. 


%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n %{name}-%{version}
# remove all binary libs
for j in $(find . -name "*.jar"); do
	mv $j $j.no
done
cp %{SOURCE1} build.xml
mkdir -p config/junit/runner
cp %{SOURCE2} config/junit/runner/excluded.properties
touch config/dependtemplate.txt

%build
cat /dev/null > .ant.properties
echo java1.5.home=/usr/lib/jvm/java-1.5.0 >> .ant.properties
echo build.j2ee1.3=true >> .ant.properties
echo java2html.home=/usr/share/java >> .ant.properties

pushd lib
ln -sf $(build-classpath commons-digester) commons-digester.jar
ln -sf $(build-classpath oro) jakarta-oro-2.0.8.jar
ln -sf $(build-classpath junit) junit.jar
ln -sf $(build-classpath nekohtml) nekohtml.jar
ln -sf $(build-classpath xerces-j2) xercesImpl.jar
ln -sf $(build-classpath jboss4/jboss-j2ee) jboss-j2ee.jar
ln -sf $(build-classpath commons-beanutils) commons-beanutils.jar
ln -sf $(build-classpath struts) struts.jar
ln -sf $(build-classpath mockejb) mockejb.jar
ln -sf $(build-classpath commons-collections) commons-collections.jar
ln -sf $(build-classpath commons-validator) commons-validator.jar
ln -sf $(build-classpath xml-commons-apis) xml-apis.jar
ln -sf $(build-classpath servletapi5) servlet-api.jar
ln -sf $(build-classpath commons-logging) commons-logging.jar
ln -sf $(build-classpath cglib) cglib-full-2.0-RC2.jar
ln -sf $(build-classpath jspapi) jsp-api.jar
ln -sf $(build-classpath jdom) jdom.jar
ln -sf $(build-classpath jaranalyzer) jaranalyzer-0.9.3.jar
pushd j2ee1.3
ln -sf $(build-classpath servletapi4) servlet.jar
ln -sf /var/lib/j2sdkee-1.3-sun/lib/j2ee.jar .
popd
popd
ant

%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}/%{name}


install -m 0644 bin/%{name}-%{version}/lib/%{name}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-%{version}.jar
install -m 0644 bin/%{name}-%{version}/lib/%{name}-jca.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-jca-%{version}.jar
install -m 0644 bin/%{name}-%{version}/lib/%{name}-servlet.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-servlet-%{version}.jar
install -m 0644 bin/%{name}-%{version}/lib/%{name}-tag.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-tag-%{version}.jar
install -m 0644 bin/%{name}-%{version}/lib/%{name}-jms.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-jms-%{version}.jar
install -m 0644 bin/%{name}-%{version}/lib/%{name}-struts.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-struts-%{version}.jar
install -m 0644 bin/%{name}-%{version}/lib/%{name}-jdbc.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-jdbc-%{version}.jar
install -m 0644 bin/%{name}-%{version}/lib/%{name}-ejb.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-ejb-%{version}.jar

install -m 0644 bin/%{name}-%{version}/lib/j2ee1.3/%{name}-j2ee1.3.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-j2ee1.3-%{version}.jar
install -m 0644 bin/%{name}-%{version}/lib/j2ee1.3/%{name}-servlet-j2ee1.3.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-servlet-j2ee1.3-%{version}.jar
install -m 0644 bin/%{name}-%{version}/lib/j2ee1.3/%{name}-tag-j2ee1.3.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-tag-j2ee1.3-%{version}.jar
install -m 0644 bin/%{name}-%{version}/lib/j2ee1.3/%{name}-struts-j2ee1.3.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-struts-j2ee1.3-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr doc/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}


rm -rf doc/{build.txt,api,api_impl}

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p readme.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_datadir}/doc/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}/readme.txt
%{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/%{name}/*.jar

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%changelog
* Thu Oct 20 2005 Ralph Apel <r.apel@r-apel.de> - 0:0.3.5-1jpp
- First JPackage build
